<script lang="ts">
	import { getRoomName, getRoomPrice, getTotalPrices } from './../../../lib/room.ts';
	import { clearCart, getCart, getCartSize, removeItemFromCart } from '$lib/reservation';
	import { onMount } from 'svelte';
	import { ChevronDownIcon, ShoppingCartIcon, Trash2Icon } from 'svelte-feather-icons';
	import { fade, slide } from 'svelte/transition';
	import type { ReservationInput } from '../../api/reservation/types';
	import { getRoomImage } from '$lib/room';
	import Button from '../../../components/Main/Button.svelte';
	import { format } from 'date-fns';
	import { refreshCart } from '../../../stores/reservation.js';
	import Loader from '../../../components/Main/Loader.svelte';
	import { goto } from '$app/navigation';
	import ConfirmModal from '../../../components/Main/ConfirmModal.svelte';
	import { makeReservation } from '../../api/reservation/reservation.js';
	import toast from 'svelte-french-toast';
	import { checkIfAmountValid } from '../../api/customer/customer.js';
	import { updateWalletStore } from '../../../stores/stores.js';
	import fr from 'date-fns/locale/fr';

	let cartItems: ReservationInput[] = [];
	let loading = true;
	let totalPrice = 0;

	let customerID = '';
	let enoughMoney = false;
	onMount(async () => {
		cartItems = getCart();
		customerID = sessionStorage.getItem('customerID') ?? '';
		totalPrice = getTotalPrices(cartItems);

		enoughMoney = (await checkIfAmountValid(customerID, totalPrice / 2)).success;

		loading = false;
	});

	$: if ($refreshCart) {
		cartItems = getCart();
	}

	const refreshCheckAmount = async () => {
		enoughMoney = (await checkIfAmountValid(customerID, totalPrice / 2)).success;
	};

	$: if ($updateWalletStore) {
		refreshCheckAmount();
	}

	$: totalPrice = getTotalPrices(cartItems);
	let showConfirmModal = false;

	const makeReservations = async () => {
		loading = true;
		const requestBody = JSON.stringify(cartItems);

		await fetch('https://localhost:7067/api/reservation/list', {
			method: 'POST',
			body: requestBody,
			headers: {
				'Content-Type': 'application/json'
			}
		})
			.then(async (response) => {
				console.log('response', response.status);
				if (response.status === 201) {
					toast.success(
						'Reservation(s) enregistrée(s) avec succès. Vous avez été debité de 50% du montant total. (' +
							totalPrice / 2 +
							'€)'
					);

					clearCart();
					$updateWalletStore = true;
					$refreshCart = true;
					showConfirmModal = false;
				}
			})
			.catch((error) => {
				console.log('error', error);
				return [];
			});

		loading = false;
	};

	let openRegulation = false;

	$: console.log('enoughMoney', enoughMoney);
</script>

<div class="flex flex-col gap-4 w-full p-4 overflow-y-scroll">
	{#if loading}
		<div class="flex flex-col items-center justify-center gap-4 grow">
			<Loader classes="w-12 h-12" />
		</div>
	{:else}
		<!-- svelte-ignore a11y-no-static-element-interactions -->
		<div class="w-full flex flex-col border border-primary-500 rounded-t-md">
			<div
				class="w-full flex justify-between items-center cursor-pointer p-4 bg-primary-500 text-white rounded-t-md"
				on:click={() => {
					openRegulation = !openRegulation;
				}}
				on:keydown
			>
				<span class="">Règlement sur les réservations</span>
				<ChevronDownIcon class="transform {openRegulation ? 'rotate-180' : ''}" />
			</div>

			{#if openRegulation}
				<span class="w-full p-2" transition:slide>
					Chez <b>Tokio</b>, une reservation se déroule en 2 étapes
					<ul>
						<li>- 50% du montant est payé lors de la réservation.</li>
						<li>- Les 50% restants sont payés lors de la confirmation</li>
					</ul>
					<br />
					Merci de votre compréhension
				</span>
			{/if}
		</div>

		{#each cartItems as item, index}
			<div
				class="relative flex items-center justify-between gap-2 border border-black rounded-lg w-full pe-4"
				transition:fade
			>
				<img
					src={getRoomImage(item.roomType)}
					alt="room"
					class="w-32 md:w-40 aspect-square rounded-l-lg"
				/>
				<div class="flex flex-col gap-2 text-center">
					<span class="text-xl">Chambre {getRoomName(item.roomType)}</span>
					<span>
						Du {format(new Date(item.checkInDate), 'dd MMM yyyy', { locale: fr })}
						au {format(
							new Date(item.checkInDate).setDate(
								new Date(item.checkInDate).getDate() + item.numberOfNights
							),
							'dd MMM yyyy',
							{ locale: fr }
						)}
					</span>
					<span
						class="absolute bottom-0 left-0 md:left-auto md:right-0 w-fit border md:border-none border-white p-2 text-base md:text-lg font-medium
							rounded-bl-md rounded-tr-md md:rounded-bl-none md:rounded-tr-none md:rounded-tl-md md:rounded-br-md bg-primary-500 text-white"
						>Prix: {getRoomPrice(item.roomType)}€</span
					>
				</div>
				<Button
					type="secondary"
					on:click={() => {
						removeItemFromCart(index);
						cartItems = getCart();
						$refreshCart = true;
					}}
				>
					<Trash2Icon />
				</Button>
			</div>
		{:else}
			<div class="flex flex-col items-center justify-center gap-4 grow">
				<span class="text-2xl font-semibold">Votre panier est vide</span>
				<ShoppingCartIcon class="w-24 h-24" />
				<Button type="primary" on:click={() => goto('/reserve')}>Réserver une chambre</Button>
			</div>
		{/each}
		{#if cartItems.length > 0}
			<div class="fixed bottom-0 left-0 bg-transparent w-full flex items-center justify-center p-2">
				<div
					class="relative bg-primary-500 w-full rounded-xl flex justify-between border border-primary-500"
				>
					<div class="bg-white special-round p-2 w-2/5 font-semibold">
						A payer maintenant : {totalPrice / 2}€
					</div>
					<button
						class="relative grow flex items-center justify-end px-4 text-white text-lg bouton rounded-r-xl {enoughMoney
							? ''
							: 'cursor-not-allowed'}
						before:bg-gradient-to-r before:from-transparent {enoughMoney
							? 'before:via-success-600'
							: 'before:via-error-600'} before:to-transparent
						"
						on:click={() => {
							showConfirmModal = true;
						}}
						disabled={!enoughMoney}
					>
						<div class="absolute top-0 right-0 h-full flex items-center p-2 text-white text-lg">
							{#if enoughMoney}
								<span>Confirmer & payer</span>
							{:else}
								<span>Balance insuffisante</span>
							{/if}
						</div>
					</button>
				</div>
			</div>
		{/if}
	{/if}
</div>

<ConfirmModal
	title="Confirmation"
	bind:show={showConfirmModal}
	{loading}
	callback={makeReservations}
>
	<span>
		Vous aller réserver {cartItems.length} chambre{cartItems.length > 1 ? 's' : ''} pour un total de
		{totalPrice}€.
	</span>
	<span> 50% du montant total sera débité de votre compte. ({totalPrice / 2}€) </span>
</ConfirmModal>

<style>
	.special-round {
		border-radius: 0.75rem 40px 0.25rem 0.75rem;
	}
	.bouton {
		position: relative;
		overflow: hidden;
		transition: color 0.5s ease-in-out;
	}

	.bouton::before {
		content: '';
		position: absolute;
		top: 0;
		left: 100%;
		width: 200%;
		height: 100%;
		transition: left 0.3s ease-in-out;
	}

	.bouton:hover::before {
		left: -10%;
	}
</style>
